/* -*- c++ -*- */
/*
 * Copyright 2004,2009,2010,2012 Free Software Foundation, Inc.
 *
 * This file is part of GNU Radio
 *
 * GNU Radio is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 *
 * GNU Radio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNU Radio; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street,
 * Boston, MA 02110-1301, USA.
 */

// WARNING: this file is machine generated. Edits will be overwritten

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <integrate_ff_impl.h>
#include <gr_io_signature.h>

namespace gr {
  namespace blocks {

    integrate_ff::sptr integrate_ff::make(int decim)
    {
      return gnuradio::get_initial_sptr(new integrate_ff_impl(decim));
    }

    integrate_ff_impl::integrate_ff_impl(int decim)
      : gr_sync_decimator("integrate_ff",
			  gr_make_io_signature(1, 1, sizeof (float)),
			  gr_make_io_signature(1, 1, sizeof (float)),
			  decim),
      d_decim(decim),
      d_count(0)
    {
    }

    int
    integrate_ff_impl::work(int noutput_items,
		      gr_vector_const_void_star &input_items,
		      gr_vector_void_star &output_items)
    {
      const float *in = (const float *)input_items[0];
      float *out = (float *)output_items[0];

      for (int i = 0; i < noutput_items; i++) {
	out[i] = (float)0;
	for (int j = 0; j < d_decim; j++)
	  out[i] += in[i*d_decim+j];
      }
      
      return noutput_items;
    }

  } /* namespace blocks */
} /* namespace gr */
